SystemOrganization addCategory: #'Manifest-Core'!

!RBToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 93! !

!RBGuardClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBGuardClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 111! !

ComposableModel subclass: #CriticBrowser
	instanceVariableNames: 'rule criticsModel toolbarModel manifestCache sourceCodeModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!CriticBrowser commentStamp: '<historical>' prior: 0!
I'am a browser for the SmallLint Critics of a rule

Instance Variables
	criticsModel:		<Object>
	rule:		<Object>
	textModel:		<Object>
	toolbarModel:		<Object>

criticsModel
	- xxxxx

rule
	- xxxxx

textModel
	- xxxxx

toolbarModel
	- xxxxx
!

!CriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 1/30/2012 16:05'!
internSpec

	^{ #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #criticsModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@0.5).	(0@0 corner: 0@(-15)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.															
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!CriticBrowser class methodsFor: 'specs' stamp: 'SimonAllier 1/25/2012 11:05'!
title

	^ 'Critic Browser'! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/2/2012 16:20'!
actionToPerformOnTextModel

	sourceCodeModel action:  [:text | 	|selec|
	
		selec := criticsModel selectedItem"s".
		((selec isCompiledMethod) and: [rule isTransformationRule not])
			ifTrue: [
				selec methodClass compile: text] 
			ifFalse: [
				Compiler evaluate:  text ]
		]
	
! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/9/2012 11:02'!
addAllCriticsToFalsePositive
	self criticsHolder contents do: [:critic | self addCriticToFalsePositive: critic].
	criticsModel updateList 	
			! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 11:48'!
addClassToFalsePositive

	| manifestBuilder|
	criticsModel selectedItems ifNotNil: [ :critics |
		critics do: [ :critic |
			manifestBuilder := BuilderManifest on: critic. 
			critic isCompiledMethod 
				ifTrue: [ manifestBuilder addRejectClass: critic methodClass]
				ifFalse: [ manifestBuilder addRejectClass: critic]].
		criticsModel updateList
	]	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/10/2012 13:26'!
addCriticToFalsePositive
	criticsModel selectedItems
		ifNotNil: [:critics | critics do: [:critic |
				self addCriticToFalsePositive: critic]].
		criticsModel updateList 	 	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 3/2/2012 15:17'!
addCriticToFalsePositive: aCritic
	| ruleId versionId manifestBuilder |

	ruleId :=  rule class uniqueIdentifierNumber.
	versionId :=   rule class identifierMinorVersionNumber.

	manifestBuilder := BuilderManifest on: aCritic.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
				
	 manifestBuilder addFalsePositive: aCritic of: ruleId version: versionId.
	manifestCache addFalsePositive: aCritic onRuleId: versionId.! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 11:48'!
addRuleToFalsePositive

	| manifestBuilder |
	criticsModel selectedItem ifNotNil: [
		manifestBuilder := BuilderManifest on: (criticsModel selectedItem). 
	
		manifestBuilder addRejectRule: rule class uniqueIdentifierNumber].
	criticsModel updateList 	
	! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/5/2012 14:09'!
browseCritic
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2012 16:05'!
criticsHolder

	^ criticsModel listHolder! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2012 16:06'!
criticsHolder: anHolder
	
	criticsModel listHolder: anHolder! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2012 16:03'!
criticsModel

	^ criticsModel! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/10/2012 13:16'!
falsePositiveColor

	^ Color darkGray! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/7/2012 13:49'!
formatDisplayCritic: aCritic ForRuleId: ruleId versionId: versionId 
	|  manifestBuilder class ret| 
	

	"ruleId := rule class uniqueIdentifierNumber.
	versionId := rule class identifierMinorVersionNumber."
	manifestBuilder := BuilderManifest on: aCritic.	
	
	 aCritic isCompiledMethod
		ifTrue: 	[class := aCritic methodClass.
				 ret := class name, '>>#',  aCritic selector] 
		ifFalse: [class := aCritic. 
			ret := aCritic name].
		
	
		
	 ^ ((manifestBuilder containsFalsePositive: aCritic onRule:  ruleId version: versionId) or:
		[(manifestBuilder containsRejectedRule: ruleId) or:
		[manifestBuilder containsRejectedClass: class]])
		ifTrue: [ret asStringMorph color: self falsePositiveColor ]
		ifFalse: [ret asStringMorph]! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/10/2012 13:36'!
iconFor: anItem

	(self isRejected: anItem)
		ifTrue: [ ^ NautilusIcons iconNamed: #breakpoint ].
	^ NautilusIcons iconNamed: #breakpoint! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/6/2012 10:38'!
implementorsOfCritic

	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [(AbstractTool new ) browseMessagesFrom:  elem selector] ] ! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/7/2012 13:50'!
initialize
	"Initialization code for MethodBrowser"
	
	super initialize.

	criticsModel := self instantiate: IconListModel.
	sourceCodeModel := self instantiate: TextModel.
	toolbarModel := self instantiate: CriticToolbar.
	criticsModel beMultipleSelection.
	self focusOrder
		add: criticsModel;
		add: toolbarModel;
		add: sourceCodeModel.

		criticsModel wrappingBlock: [:selec |
			self formatDisplayCritic: selec ForRuleId: (rule class uniqueIdentifierNumber)
	versionId: (rule class identifierMinorVersionNumber) ]. 
	
	criticsModel menu: [:a :b | self menu: a shifted: b ].
	
	self whenSelectedItemChangesOnListModel.
	self actionToPerformOnTextModel.
	self toolbarModel whenFalsePositiveClickedDo: [ self addCriticToFalsePositive ].
	self toolbarModel whenTransformClickedDo: [ self removeSelectedItemFromListModel ].
	"criticsModel icons: [:item | self iconFor: item ]"
! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/10/2012 13:31'!
isRejected: aMethod 
	
	
	^ true! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/2/2012 15:16'!
manifestCache: aManifestCache
 
manifestCache := aManifestCache! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/7/2012 14:09'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse' translated
		target: self
		selector: #browseCritic;
		add: 'Senders' translated
		target: self
		selector: #sendersOfCritic;
		add: 'Implementors' translated
		target: self
		selector: #implementorsOfCritic;
		add: 'Mark selected class as false Positive' translated
		target: self
		selector: #addClassToFalsePositive;
		add: 'Unmark selected class as false Positive' translated
		target: self
		selector: #removeClassToFalsePositive;
		add: 'Mark selected critic as false Positive' translated
		target: self
		selector: #addCriticToFalsePositive;
		add: 'Unmark selected critic as false Positive' translated
		target: self
		selector: #removeCriticToFalsePositive;
		add: 'Mark all selected critics as false Positive' translated
		target: self
		selector: #addAllCriticsToFalsePositive;
		add: 'Unmark all selected critics as false Positive' translated
		target: self
		selector: #addRuleToFalsePositive;
		
		add: 'Mark rule as false Positive' translated
		target: self
		selector: #addRuleToFalsePositive;
		add: 'Unmark rule as false Positive' translated
		target: self
		selector: #removeRuleToFalsePositive.
		
	^ aMenu! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/9/2012 11:04'!
removeAllCriticsToFalsePositive
	self criticsHolder contents do: [:critic | self removeCriticToFalsePositive: critic].
	criticsModel updateList 	
			! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 11:48'!
removeClassToFalsePositive

	| manifestBuilder critic|
	criticsModel selectedItem ifNotNil: [
		manifestBuilder := BuilderManifest on: (criticsModel selectedItem). 
		critic := criticsModel selectedItem.
	
		critic isCompiledMethod 
			ifTrue: [ manifestBuilder removeRejectClass: critic methodClass]
			ifFalse: [ manifestBuilder removeRejectClass: critic]].
		criticsModel updateList 	
	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/10/2012 13:27'!
removeCriticToFalsePositive
	criticsModel selectedItems
		ifNotNil: [:critics | critics do: [:critic |
				 self removeCriticToFalsePositive: critic]].
		criticsModel updateList 	  ! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 11:48'!
removeCriticToFalsePositive: aCritic
	| ruleId versionId manifestBuilder |

	ruleId :=  rule class uniqueIdentifierNumber.
	versionId :=   rule class identifierMinorVersionNumber.

	manifestBuilder := BuilderManifest on: aCritic.
	
	(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
				
	 manifestBuilder removeFalsePositive: aCritic of: ruleId version: versionId	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 3/7/2012 14:12'!
removeRuleToFalsePositive

	| manifestBuilder |
	criticsModel selectedItem ifNotNil: [
		manifestBuilder := BuilderManifest on: (criticsModel selectedItem). 
		manifestBuilder removeRejectRule: rule class uniqueIdentifierNumber]
		.
	criticsModel updateList.
	! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 2/3/2012 16:19'!
removeSelectedItemFromListModel
	| item block |
	item := criticsModel selectedItem.
	block := item isCompiledMethod
		ifTrue: [ [ :each | each methodClass = item methodClass and: [ each selector = item selector ] ] ]
		ifFalse: [ [ :each | each = item ] ].
	criticsModel listHolder contents: (criticsModel listHolder contents reject: block).
	criticsModel updateList! !

!CriticBrowser methodsFor: 'protocol' stamp: 'SimonAllier 1/30/2012 16:04'!
resetSelection

	self criticsModel resetSelection! !

!CriticBrowser methodsFor: 'protocol' stamp: 'SimonAllier 3/5/2012 14:38'!
rule: aRule

	" I should disptach depending if I am browsing classes or methods "
	| result |
	rule := aRule.
	
	rule ifNil: [^ self criticsHolder contents: {}].
	
	result := rule result.
	result
		ifNil: [ ^ self criticsHolder contents: {} ].
	
	result isSelectorEnvironment
		ifTrue: [ 
			| array |
			array := OrderedCollection new: result numberSelectors.
			result classes do: [:cl | 
				result selectorsForClass: cl do: [:sel | array add:  (cl>>sel)]]. 
			^ self criticsHolder contents: array ].
	
	self criticsHolder contents: result allClasses asArray! !

!CriticBrowser methodsFor: 'private' stamp: 'SimonAllier 1/27/2012 16:22'!
selectionIntervalFor: aString
	^ rule result selectionIntervalFor: aString! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/6/2012 10:42'!
sendersOfCritic

	| abstractTool |
	
	abstractTool := AbstractTool new. 	
	criticsModel selectedItem
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ abstractTool browseClassRefsOf: elem]
				ifFalse: [abstractTool browseSendersOfMessagesFrom: elem selector] ] ! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/2/2012 16:20'!
setTextModelFoClass: cl
	| interval |

	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: cl definition.
	sourceCodeModel behavior: nil .
	
	interval := (self selectionIntervalFor: cl definition).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/2/2012 16:20'!
setTextModelForMethod: selection
	| interval |

	sourceCodeModel aboutToStyle: true.
	sourceCodeModel text: selection sourceCode.
	sourceCodeModel behavior: selection methodClass.
	
	interval := (self selectionIntervalFor: selection sourceCode).
	interval ifNotNil: [sourceCodeModel setSelection: interval].
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/2/2012 16:20'!
setTextModelForNil

	rule ifNotNil: [
		sourceCodeModel aboutToStyle: false.
		sourceCodeModel text: rule rationale.
		sourceCodeModel behavior: nil.
		toolbarModel critic: nil ]
	
	
					! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 3/2/2012 16:20'!
setTextModelForTransformationRule: selection
	
	| textDiff change |
	rule result.
	change := rule changes detect: [:ch |
		((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)].
	textDiff := (TextDiffBuilder
		from: (selection sourceCode)
		to:  (change source) inClass: selection methodClass) buildDisplayPatch.
	
	sourceCodeModel behavior: nil.
	sourceCodeModel text: textDiff.
	sourceCodeModel aboutToStyle: false.

									
					! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 1/30/2012 16:05'!
takeKeyboardFocus

	^ self criticsModel takeKeyboardFocus! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 3/2/2012 16:20'!
textModel

	^ sourceCodeModel! !

!CriticBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/24/2012 16:24'!
toolbarModel

	^ toolbarModel! !

!CriticBrowser methodsFor: 'initialization' stamp: 'SimonAllier 2/13/2012 10:47'!
whenSelectedItemChangesOnListModel

	criticsModel whenSelectedItemChanges: [:selection |
		(selection
			ifNil: [self setTextModelForNil]
			ifNotNil: [
				toolbarModel rule: rule. 
				toolbarModel critic: selection.
				rule isTransformationRule 
					ifTrue: [self setTextModelForTransformationRule: selection]
					ifFalse: [				
					rule result isSelectorEnvironment 
							ifTrue: [  self setTextModelForMethod: selection]
							ifFalse:  [ self setTextModelFoClass: selection]]
				])]! !

ComposableModel subclass: #CriticRulesBrowser
	instanceVariableNames: 'criticModel window rulesModel environment manifestCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!CriticRulesBrowser commentStamp: '<historical>' prior: 0!
I'am a browser for the SmallLint Critics

example: 
	rule :=  RBCompositeLintRule filterRules.
environment := (PackageEnvironment new packages: {PackageInfo named: 'Manifest'}).

(CriticRulesBrowser runRule: rule onEnvironment: environment)
	openWithSpec.
	
!

!CriticRulesBrowser class methodsFor: 'menu' stamp: 'SimonAllier 2/29/2012 15:35'!
finderMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #CriticBrowser)
		action: [self open];
		order: 0;
		parent: #Tools;
		help: 'To manage rule checks';
		icon: self icon! !

!CriticRulesBrowser class methodsFor: 'menu' stamp: 'SimonAllier 3/5/2012 13:56'!
icon
	"Answer an icon for the receiver."
	
	^self theme smallWarningIcon! !

!CriticRulesBrowser class methodsFor: 'spec' stamp: 'SimonAllier 1/30/2012 16:05'!
internSpec
	^ { #PanelMorph.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #rulesModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 0.5@0.5 ).	(0@0 corner: 0@(-15)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #criticModel. #criticsModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0.5@0 corner: 1@0.5 ).	(0@0 corner: 0@(-15)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #criticModel. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(-15) corner: 0@15). }}.										
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #criticModel. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@15 corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 3/7/2012 13:39'!
open

	| cbr env rules  |
	rules :=  RBCompositeLintRule filterRules rules.
	env := (RBPackageEnvironment new packages: ((PackageInfo allPackages asOrderedCollection) copyFrom: 1 to: 20)).
	
	self openOnRule: rules onEnvironment:  env
	

	.! !

!CriticRulesBrowser class methodsFor: 'instance creation' stamp: 'SimonAllier 3/7/2012 13:40'!
openOnRule: aRule onEnvironment: aEnv

	| cbr |
	cbr :=  self new rules: aRule;
		environment: aEnv;
		initManifestCache;
		yourself.
		
	cbr openWithSpec.
	cbr applyRules ! !

!CriticRulesBrowser class methodsFor: 'menu' stamp: 'StephaneDucasse 2/28/2012 15:36'!
theme
	^ UITheme current! !

!CriticRulesBrowser class methodsFor: 'spec' stamp: 'SimonAllier 1/25/2012 13:55'!
title

	^ 'Critic Browser'! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 3/2/2012 15:12'!
addRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItems ifNotNil: [ :rules |
		rules do: [:rule |
			rule result classesDo: [:cl |
				manifestBuilder := BuilderManifest on: cl. 
				manifestBuilder addRejectRule: rule class uniqueIdentifierNumber]
			]].
	criticModel criticsModel updateList. 	
	! !

!CriticRulesBrowser methodsFor: 'to implement' stamp: 'SimonAllier 3/5/2012 11:18'!
addTruePositive: aItem onRule: aRule	

	| ruleId versionId manifestBuilder |

	ruleId :=  aRule class uniqueIdentifierNumber.
	versionId :=   aRule class identifierMinorVersionNumber.

	manifestBuilder := BuilderManifest on: aItem.
	
	(manifestBuilder hasTruePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installTruePositiveOf: ruleId version: versionId].
				
	manifestBuilder addTruePositive: aItem of: ruleId version: versionId.
	"manifestCache addTruePositive: aItem  onRuleId: versionId."
	! !

!CriticRulesBrowser methodsFor: 'as yet unclassified' stamp: 'SimonAllier 3/5/2012 15:10'!
applyRules
	| checker rules packageCount nbPackage process |

	rules :=  (rulesModel getList).
	rules do: [:each | each resetResult].
	checker := RBSmalllintChecker new.
	checker
		rule: rules;
		context: RBSmalllintContext new.
	nbPackage := environment packages size.
	packageCount := 0.
	process := [  
		environment packageNames do: [:package |
			packageCount := packageCount + 1.
			self setTitle: 'run rules on ', package, ' (',packageCount asString, '/', nbPackage asString ,')'  .
			checker runWithManifest: rules on: package.
			rulesModel  updateList ]. 	
			self setTitle: 'Critics Browser'  .
		rulesModel updateList 
	]
		newProcess.
	process name: 'lint'.
	process resume.
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 2/1/2012 16:56'!
browseRule
	rulesModel selectedItem browse! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 3/2/2012 10:59'!
classModified: anAnnouncement
	| context ruleBis class rule |
	class := anAnnouncement itemClass.
	
	class isManifest
		ifTrue: [ ^ self ].
		
	(environment classes anySatisfy: [ :cl | class = cl ])
		ifFalse: [ ^ self ].
	context := RBSmalllintContext new.
	rule := rulesModel selectedItem.
	ruleBis := rule class new.
	ruleBis resetResult.
	context selectedClass: class.
	ruleBis checkClass: context.
	ruleBis result isEmpty
		ifFalse: [ ^ self ].
	self addTruePositive: class onRule: rule.
	criticModel removeSelectedItemFromListModel.
	self removeClass: class onRule: rule.
	rulesModel changed: #getList! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 2/9/2012 11:40'!
classRemoved: anAnnouncement
	(environment classes anySatisfy: [ :cl | anAnnouncement removedClass = cl ])
		ifFalse: [ ^ self ].
	rulesModel getList
		do: [ :rule | self removeClass: anAnnouncement removedClass onRule: rule].
	rulesModel changed: #getList.! !

!CriticRulesBrowser methodsFor: 'to implement' stamp: 'SimonAllier 2/10/2012 13:06'!
classReorganized: aClassReorganized 
! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/25/2012 13:35'!
criticModel
	^ criticModel! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 16:43'!
doNotUnderstandThisRule
	| ruleId versionId manifestBuilder |

	ruleId :=  DoNotUnderstandThisRule uniqueIdentifierNumber.
	versionId :=  DoNotUnderstandThisRule identifierMinorVersionNumber.

	rulesModel selectedItem ifNotNil: [ :rule |
		manifestBuilder := BuilderManifest on: rule class. 
		(manifestBuilder hasFalsePositiveOf: ruleId version: versionId) 
			ifFalse: [manifestBuilder installFalsePositiveOf: ruleId version: versionId].
	 	manifestBuilder addFalsePositive: (rule class) of: ruleId version: versionId
	]

	! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 1/31/2012 15:49'!
environment: aEnv
	environment := aEnv
! !

!CriticRulesBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 12:11'!
initManifestCache
	manifestCache :=  (CachedManifest 
		onRules: (rulesModel getList)
		environment: environment).
		
		! !

!CriticRulesBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 16:45'!
initRuleWrappingBlock

	rulesModel wrappingBlock: [:rule | 
		| rId fp tp total text|
		rId := rule class uniqueIdentifierNumber.
		fp := (manifestCache falsePositiveOf: rId) size asString.
		tp := (manifestCache truePositiveOf: rId) size asString.
		total :=  rule problemCount asString.
		text := rule name, ' (' , fp, '/', total, ', tp: ' ,tp, ')'.
		(rule problemCount = 0)
			ifTrue: 	[ text ] 
			ifFalse: [text asText allBold ]
	]! !

!CriticRulesBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 15:50'!
initialize
	"Initialization code for CriticRulesBrowser"
	
	 super initialize.
	
	rulesModel := self instantiate: ListComposableModel.
	criticModel := CriticBrowser new.
	rulesModel beMultipleSelection.
	
	rulesModel whenSelectedItemChanges:[:rule |
		criticModel resetSelection.
	 	criticModel rule: rule. 
		criticModel manifestCache: manifestCache.
		criticModel setTextModelForNil].
		
	
	rulesModel menu: [:a :b | self menu: a shifted: b ].
	self initRuleWrappingBlock.
	
	
	
	self registerToAnnouncements! !

!CriticRulesBrowser methodsFor: 'initialize-release' stamp: 'SimonAllier 2/29/2012 16:27'!
menu: aMenu shifted: aBoolean

	aMenu
		add: 'Browse rule' translated
		target: self
		selector: #browseRule;
		add: 'Do not understand this rule' translated
		target: self
		selector: #doNotUnderstandThisRule;
		add: 'mark rule as false positive' translated
		target: self
		selector: #addRuleToFalsePositive;
			add: 'unmark rule as false positive' translated
		target: self
		selector: #removeRuleToFalsePositive.
		
		
		
	^ aMenu! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 3/6/2012 15:39'!
methodAdded: anAnnouncement

	 anAnnouncement itemClass isManifest
		ifTrue: [
			self udapteManifestCacheOf: anAnnouncement ]! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 3/2/2012 16:34'!
methodModified: anAnnouncement

	| context ruleBis class selector rule |
	
	class := anAnnouncement itemClass.
	class isManifest
		ifTrue: [
			self udapteManifestCacheOf: anAnnouncement.
			 ^ self ].

	(environment classes anySatisfy: [ :cl | class = cl ])
		ifFalse: [ ^ self ].

	context := RBSmalllintContext new.
	selector := anAnnouncement itemSelector.
	rule := rulesModel selectedItem.
	ruleBis := rule class new.
	ruleBis resetResult.
	context selectedClass: class.
	ruleBis checkClass: context.
	context selector: selector.
	ruleBis checkMethod: context.
	ruleBis result isEmpty
		ifFalse: [ ^ self ].
	self addTruePositive: (anAnnouncement item)  onRule: rule.
	criticModel removeSelectedItemFromListModel.
	self removeClass: class selector: selector onRule: rule.
	
	rulesModel changed: #getList! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 2/13/2012 14:39'!
methodRemoved: anAnnouncement
	(environment classes anySatisfy: [ :cl | anAnnouncement itemClass = cl ])
		ifFalse: [ ^ self ].
	rulesModel getList
		do: [ :rule | self removeClass: anAnnouncement itemClass selector: anAnnouncement itemSelector onRule: rule].
	rulesModel changed: #getList.! !

!CriticRulesBrowser methodsFor: 'as yet unclassified' stamp: 'SimonAllier 3/1/2012 11:35'!
numberOfFalsePositiveFor: aRule

	|manifestBuilder rId rV fp|
	
	rId = aRule class uniqueIdentifierNumber.
	rId = aRule class  identifierMinorVersionNumber.
	fp := Set new.
	
	environment packageNames do: [ :package | 
		manifestBuilder := BuilderManifest on: package.
		(manifestBuilder hasFalsePositiveOf: rId version: rV)
			ifTrue: [
				fp addAll: (manifestBuilder falsePositiveOf: rId version: rV)
	]].
	
	^ fp size	
		
! !

!CriticRulesBrowser methodsFor: 'as yet unclassified' stamp: 'SimonAllier 3/1/2012 11:35'!
numberOfTruePositiveFor: aRule

	|manifestBuilder rId rV fp|
	
	rId = aRule class uniqueIdentifierNumber.
	rId = aRule class  identifierMinorVersionNumber.
	fp := Set new.
	
	environment packageNames do: [ :package | 
		manifestBuilder := BuilderManifest on: package.
		(manifestBuilder hasTruePositiveOf: rId version: rV)
			ifTrue: [
				fp addAll: (manifestBuilder truePositiveOf: rId version: rV)
	]].
	
	^ fp size	
		
! !

!CriticRulesBrowser methodsFor: 'display' stamp: 'StephaneDucasse 2/28/2012 15:48'!
open

	window := self openWithSpec.
	^ window.! !

!CriticRulesBrowser methodsFor: 'display' stamp: 'SimonAllier 1/27/2012 12:18'!
openWithSpec

	window := super openWithSpec.
	^ window.! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 2/8/2012 14:45'!
registerToAnnouncements

	SystemAnnouncer announcer weak
		"on: RPackageCreated send: #packageCreated: to: self;
		on: RPackageRenamed send: #packageRenamed: to: self;"
	
		"on: ClassAdded send: #classAdded: to: self;"
		"on: ClassCommented send: #classCommented: to: self;
		on: ClassRecategorized send: #classRecategorized: to: self;"
		on: ClassRemoved send: #classRemoved: to: self;
		"on: ClassRenamed send: #classRenamed: to: self;"
		on: ClassReorganized send: #classReorganized: to: self;
		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		
		on: MethodRemoved send: #methodRemoved: to: self.
		
"		on: ProtocolAdded send: #classRecategorized: to: self;
		on: ProtocolRemoved send: #classRecategorized: to: self."! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 2/13/2012 15:14'!
removeClass: aClass  onRule: aRule
	| result |

	result := aRule result.
	result isClassEnvironment
		ifTrue: [ result removeClass: aClass ].
	result isSelectorEnvironment
		ifTrue: [ result removeClass: aClass  ].
	result isVariableEnvironment
		ifFalse: [ ^ self ].
	aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
	aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ].
	
	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 2/13/2012 14:40'!
removeClass: aClass selector: aSelector onRule: aRule
	| result |
			
	result := aRule result.
	result isClassEnvironment
		ifTrue: [ result removeClass: aClass ].
	result isSelectorEnvironment
		ifTrue: [ result removeClass: aClass selector: aSelector ].
	result isVariableEnvironment
		ifFalse: [ ^ self ].
	aClass classVarNames do: [ :var | result removeClass: aClass classVariable: var ].
	aClass instVarNames do: [ :var | result removeClass: aClass instanceVariable: var ].

	! !

!CriticRulesBrowser methodsFor: 'private' stamp: 'SimonAllier 2/29/2012 11:48'!
removeRuleToFalsePositive

	| manifestBuilder |
	rulesModel selectedItems ifNotNil: [ :rules |
		rules do: [:rule |
			rule result classesDo: [:cl |
				manifestBuilder := BuilderManifest on: cl. 
				manifestBuilder removeRejectRule: rule class uniqueIdentifierNumber]
		]].
	criticModel criticsModel updateList.
	
	! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 2/29/2012 14:30'!
rules: aCollectionOfRules

	"aCollectionOfRules do: [:rule |
		rule filteredResultWithManifest.]. 
	"
	self rulesModel items: aCollectionOfRules .
	
	
! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/30/2012 16:01'!
rulesModel

	^ rulesModel! !

!CriticRulesBrowser methodsFor: 'protocol' stamp: 'SimonAllier 1/27/2012 12:19'!
setTitle: aTitle

	self window
		ifNotNil: [:w | w title: aTitle ]! !

!CriticRulesBrowser methodsFor: 'system annoucements' stamp: 'SimonAllier 3/6/2012 16:04'!
udapteManifestCacheOf: anAnnouncement
	|fp oldFp rId selector class method|
	
	
	selector := anAnnouncement itemSelector.
	class := anAnnouncement itemClass.
	
	((selector endsWith: BuilderManifest falsePositiveEndTag) or: 
		[selector endsWith: BuilderManifest truePositiveEndTag]) 
			ifFalse: [^ self].
	
	
	rId := rulesModel selectedItem class uniqueIdentifierNumber. 
	fp := BuilderManifest new 
				unwrap: (class
				withArgs: #() 
				executeMethod: anAnnouncement item).
	oldFp :=(anAnnouncement class = MethodAdded)
		ifTrue: [ {}]
		ifFalse: [
	 		BuilderManifest new 
				unwrap: (class
				withArgs: #() 
				executeMethod: anAnnouncement oldItem)].
			
	(selector endsWith: BuilderManifest falsePositiveEndTag) 
		ifTrue: [
				manifestCache removeAllFalsePositive: oldFp onRuleId:  rId.
				manifestCache addAllFalsePositive: fp onRuleId:  rId.
			].
		
	(selector endsWith: BuilderManifest truePositiveEndTag) 
		ifTrue: [
			manifestCache addAllTruePositive: fp onRuleId:  rId.
			].
	rulesModel changed: #getList.
		
	
	
		
	
	
	rulesModel changed: #getList! !

!CriticRulesBrowser methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 12:18'!
window

	^ window! !

ComposableModel subclass: #CriticToolbar
	instanceVariableNames: 'ruleHolder criticHolder browseModel falsepositiveModel transformModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!CriticToolbar commentStamp: '<historical>' prior: 0!
I'am a toolbar for the SmallLint Critics


Instance Variables
	browseModel:		<Object>
	criticHolder:		<Object>
	falsepositiveModel:		<Object>
	ruleHolder:		<Object>
	transformModel:		<Object>

browseModel
	- xxxxx

criticHolder
	- xxxxx

falsepositiveModel
	- xxxxx

ruleHolder
	- xxxxx

transformModel
	- xxxxx
!

!CriticToolbar class methodsFor: 'specs' stamp: 'SimonAllier 1/27/2012 16:05'!
internSpec

	^ { #PanelMorph.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#browseModel.	#internSpec}.
			#addMorph:. {#model.	#transformModel.	#internSpec}.
			#addMorph:. {#model.	#falsepositiveModel.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CriticToolbar methodsFor: 'private' stamp: 'SimonAllier 3/5/2012 14:04'!
browseCritic

	criticHolder contents
		ifNotNil: [:elem | 
			elem isBehavior 
				ifTrue: [ elem theNonMetaClass  browse]
				ifFalse: [elem browse] ] ! !

!CriticToolbar methodsFor: 'accessing' stamp: 'SimonAllier 1/25/2012 10:21'!
browseModel

	^ browseModel! !

!CriticToolbar methodsFor: 'protocol' stamp: 'SimonAllier 1/25/2012 15:38'!
critic: aCritic

	criticHolder contents: aCritic! !

!CriticToolbar methodsFor: 'accessing' stamp: 'SimonAllier 1/25/2012 10:23'!
falsepositiveModel

	^ falsepositiveModel! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 2/1/2012 16:43'!
initialize

	super initialize.

	criticHolder := nil asValueHolder.
	ruleHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	transformModel := self instantiate: ButtonModel.
	falsepositiveModel := self instantiate: ButtonModel.

	self setFocusOrder.
	
	self setBrowseModel.
	self setTransformModel.
	self setFalsepositiveModel.

	self registerForChanges.! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 16:16'!
registerForChanges

	criticHolder whenChangedDo: [:contents || boolean |
		boolean := contents
						ifNil: [ false ]
						ifNotNil: [ true ].
		browseModel state: boolean.
		transformModel state: boolean.
		falsepositiveModel state: boolean.]
! !

!CriticToolbar methodsFor: 'protocol' stamp: 'SimonAllier 1/31/2012 14:06'!
rule: aRule

	ruleHolder contents: aRule.
	
	aRule isTransformationRule 
		ifTrue: [transformModel enabled: true ]	
		ifFalse: [transformModel enabled: false]
! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/25/2012 13:52'!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseCritic ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 2/9/2012 11:05'!
setFalsepositiveModel
	
	falsepositiveModel
		state: false;
		label: 'False Positive';
		action: [  ].
	
! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 16:21'!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: transformModel;
		add: falsepositiveModel.
		! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 16:07'!
setTransformModel
	
	transformModel
		state: false;
		label: 'Transform';
		action: [ self transformCritic ].
	
! !

!CriticToolbar methodsFor: 'private' stamp: 'SimonAllier 1/31/2012 14:13'!
transformCritic

	| changeCode rule selection |
	
	rule := ruleHolder contents
		ifNotNil: [:r | r ].
		
	selection := criticHolder contents
		ifNotNil: [:critic | critic].			
	selection ifNotNil: [	
		changeCode := (rule changes detect: [:ch |
			((ch changeClassName) = (selection methodClass name)) & (ch selector = selection selector)]) source.
	
		selection methodClass compile: changeCode]! !

!CriticToolbar methodsFor: 'accessing' stamp: 'SimonAllier 1/27/2012 16:05'!
transformModel

	^ transformModel! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 12:03'!
whenFalsePositiveClickedDo: aBlock

	self falsepositiveModel whenActionPerformedDo: aBlock! !

!CriticToolbar methodsFor: 'initialization' stamp: 'SimonAllier 1/27/2012 16:15'!
whenTransformClickedDo: aBlock

	self transformModel whenActionPerformedDo: aBlock! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 23! !

!RBAddRemoveDependentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAddRemoveDependentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 4! !

!RBFileBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBFileBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 71! !

!RBUnreferencedVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnreferencedVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 48! !

!RBUnwindBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnwindBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 117! !

!RBYourselfNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBYourselfNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 101! !

!RBBrowserEnvironment methodsFor: '*manifest-core' stamp: 'SimonAllier 2/28/2012 16:56'!
isParseTreeEnvironment
	^ false! !

!RBBrowserEnvironment methodsFor: '*manifest-core' stamp: 'SimonAllier 2/28/2012 16:56'!
problemLinesInCode: aString
	| lineBegin lineEnd interval |
	
	interval := self selectionIntervalFor: aString.
	lineBegin := ((aString copyFrom: 1 to: (interval first)) 
		select: [:c | c = Character  cr]) size + 1.
	lineEnd :=  ((aString copyFrom: (interval first) to: (interval last - 1)) 
		select: [:c | c = Character  cr]) size + lineBegin.
		
	^ {lineBegin. lineEnd}
	
	! !

!RBToDoCollectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoCollectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 92! !

!RBCollectSelectNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectSelectNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 60! !

!RBReturnsIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnsIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 85! !

!RGClassDefinitionTest methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/6/2012 15:19'!
testReadFrom
	"self debug: #testReadFrom"
	
	
	| st rg |
	rg := (Point) asRingDefinition.
	st := String streamContents: [:s |
		
		rg storeOn: s.
		s contents].
	self assert: (Object readFrom: st) = rg. 
	
	rg := (Point class ) asRingDefinition.
	st := String streamContents: [:s |
		
		rg storeOn: s.
		s contents].
	self assert: (Object readFrom: st) = rg ! !

!RGClassDefinitionTest methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/6/2012 15:29'!
testStoreOn
	"self debug: #testStoreOn"
	
	
	| st |
	st := String streamContents: [:s |
		
		(Point) asRingDefinition storeOn: s.
		s contents].
	self assert: st = '(RGClassDefinition named: #Point)'.
	
	st := String streamContents: [:s |
		
		(Point class) asRingDefinition storeOn: s.
		s contents].
	self assert: st = '((RGMetaclassDefinition named: #Point class) baseClass:(RGClassDefinition named: #Point))'! !

!RBUnnecessaryAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnnecessaryAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 96! !

!RBCodeCruftLeftInMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCodeCruftLeftInMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 59! !

!RBTranslateLiteralsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTranslateLiteralsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 115! !

!RBImplementedNotSentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBImplementedNotSentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 17! !

!RBInstVarInSubclassesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInstVarInSubclassesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 19! !

!RBRefersToClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBRefersToClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 35! !

!RBMethodHasNoTimeStampRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodHasNoTimeStampRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 25! !

!RBGuardingClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBGuardingClauseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 73! !

!Behavior methodsFor: '*manifest-core' stamp: 'SimonAllier 1/17/2012 11:31'!
isManifest

	^ self name beginsWith: 'Manifest'! !

!RBMissingTranslationsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingTranslationsInMenusRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 78! !

!RBModifiesCollectionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBModifiesCollectionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 80! !

!RBInconsistentMethodClassificationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInconsistentMethodClassificationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 18! !

!RBInstanceVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBInstanceVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 20! !

!RBNoClassCommentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBNoClassCommentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 32! !

!RBSmalllintChecker methodsFor: '*manifest-core' stamp: 'SimonAllier 3/5/2012 15:03'!
runWithManifest: aCollectionOfRule on: aPackageName
	|  manifest |
	
	 rule := RBCompositeLintRule new rules: aCollectionOfRule.	
	environment := (RBPackageEnvironment new packages: {PackageInfo named: aPackageName}) asSelectorEnvironment.
	
	manifest := BuilderManifest on: aPackageName.
	
	manifest rejectClasses do: [:cl| environment removeClass: cl]. "a supprimer"
	
	rule rules: (rule rules reject: [:each | 
		manifest rejectRules anySatisfy: [:id | 
			id = each class uniqueIdentifierNumber ]]).

	environment classesDo: [ :class |
		class isTrait ifFalse: [
			self checkClass: class.
			self checkMethodsForClass: class ] ].
	! !

!RBUsesAddRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUsesAddRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 99! !

!RBWhileTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBWhileTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 100! !

!RBExcessiveInheritanceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveInheritanceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 14! !

!RBCollectionCopyEmptyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionCopyEmptyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 10! !

!RBLawOfDemeterRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLawOfDemeterRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 76! !

!RBClassNotReferencedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassNotReferencedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 8! !

!RBEmptyExceptionHandlerRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEmptyExceptionHandlerRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 66! !

!RBMissingSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 31! !

!RBSearchingLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSearchingLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 86! !

!RBSubclassResponsibilityNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSubclassResponsibilityNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 39! !

!RBTempsReadBeforeWrittenRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTempsReadBeforeWrittenRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 43! !

!RBPlatformDependentUserInteractionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBPlatformDependentUserInteractionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 82! !

!RBExcessiveArgumentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveArgumentsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 13! !

!RBParseTreeEnvironment methodsFor: '*manifest-core' stamp: 'SimonAllier 2/28/2012 16:57'!
isParseTreeEnvironment
	^ true! !

!RBBetweenAndRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBetweenAndRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 107! !

!RBUncommonMessageSendRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUncommonMessageSendRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 45! !

!RBBooleanPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBooleanPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 58! !

!RBEndTrueFalseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEndTrueFalseRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 67! !

!RBFloatEqualityComparisonRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBFloatEqualityComparisonRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 72! !

!RBEqualNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualNotUsedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 68! !

!RBPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBPrecedenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 83! !

!RBToDoWithIncrementRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBToDoWithIncrementRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 94! !

!RGMethodDefinition class methodsFor: '*manifest-core' stamp: 'SimonAllier 1/23/2012 13:21'!
className: aString selector: aSelector isMetaSide: aBoolean

	^ (self class: (RGClassDefinition named: aString) selector: aSelector) isMetaSide: aBoolean; yourself! !

!RGMethodDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/23/2012 13:24'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class asString.
	aStream nextPutAll: ' className: '''.
	aStream nextPutAll: self parentName.
	
	aStream nextPutAll: ''' selector: '.
	aStream nextPutAll: self selector printString.
	
	aStream nextPutAll: ' isMetaSide: '.
	aStream nextPutAll: self isMetaSide printString.
	 aStream nextPut: $).! !

!RBUndeclaredReferenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUndeclaredReferenceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 46! !

!RBCollectionProtocolRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionProtocolRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 62! !

!RBDetectIfNoneRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDetectIfNoneRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 109! !

!RBMinMaxRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMinMaxRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 112! !

!RBExtraBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExtraBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 70! !

!RBAllAnyNoneSatisfyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAllAnyNoneSatisfyRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 104! !

!RBParseTreeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBParseTreeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 54! !

!RBMethodModifierOverrideRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierOverrideRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 27! !

!RBEquivalentSuperclassMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEquivalentSuperclassMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 12! !

!RBAtIfAbsentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAtIfAbsentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 106! !

RBBlockLintRule subclass: #DoNotUnderstandThisRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!DoNotUnderstandThisRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/29/2012 16:32'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!DoNotUnderstandThisRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/29/2012 16:33'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 140! !

!DoNotUnderstandThisRule methodsFor: 'running' stamp: 'SimonAllier 2/29/2012 16:32'!
checkClass: aContext! !

!DoNotUnderstandThisRule methodsFor: 'accessing' stamp: 'SimonAllier 2/29/2012 16:30'!
group
	^ 'Miscellaneous'! !

!DoNotUnderstandThisRule methodsFor: 'accessing' stamp: 'SimonAllier 2/29/2012 16:31'!
name
	^ 'Dot not understand this rule'! !

!DoNotUnderstandThisRule methodsFor: 'accessing' stamp: 'SimonAllier 2/29/2012 16:31'!
rationale
	^ 'Dot not understand this rule'! !

!DoNotUnderstandThisRule methodsFor: 'accessing' stamp: 'SimonAllier 2/29/2012 16:31'!
resultClass
	^ RBClassEnvironment! !

!RBBlockLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBlockLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 2! !

!RBSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSuperSendsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 114! !

!RBUnpackagedCodeRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnpackagedCodeRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 47! !

!RBTransformationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTransformationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 103! !

!RBTransformationRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/27/2012 15:45'!
isTransformationRule

	^ true ! !

!RBBadMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBadMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 5! !

!RBMultiEnvironment methodsFor: '*manifest-core' stamp: 'SimonAllier 2/28/2012 16:57'!
removeClass: aClass
	environmentDictionaries keys do: [:key |
		(environmentDictionaries at: key) removeClass: aClass]! !

!RBDefinesEqualNotHashRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDefinesEqualNotHashRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 11! !

!RBAssignmentWithoutEffectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentWithoutEffectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 57! !

!RBLongMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLongMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 24! !

!RBUnclassifiedMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnclassifiedMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 44! !

!RBMethodModifierSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 28! !

!RBNotEliminationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBNotEliminationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 113! !

!RBUnconditionalRecursionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnconditionalRecursionRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 95! !

!RBAbstractClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAbstractClassRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 3! !

!RBMethodSourceContainsLinefeedsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodSourceContainsLinefeedsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 29! !

!RBVariableReferencedOnceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableReferencedOnceRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 53! !

!RGMethodDefinitionTest methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/23/2012 13:22'!
testClassNameSelectorIsMetaSide
	"self debug: #testClassNameSelectorIsMetaSide"
	
	| rg |
	rg := RGMethodDefinition className: 'Point' selector: #x  isMetaSide: false. 	
	self assert: (rg parentName = 'Point').
	self assert: (rg parent isKindOf:RGClassDefinition).
	self assert: (rg selector = #x).
	self assert: (rg isMetaSide not).! !

!RGMethodDefinitionTest methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/23/2012 13:12'!
testReadFrom
	"self debug: #testReadFrom"
	
	
	| st rg |
	rg := (Point>>#x) asRingDefinition.
	st := String streamContents: [:s |
		
		rg storeOn: s.
		s contents].
	self assert: (Object readFrom: st) = rg ! !

!RGMethodDefinitionTest methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/23/2012 13:23'!
testStoreOn
	"self debug: #testStoreOn"
	
	
	| st |
	st := String streamContents: [:s |
		
		(Point>>#x) asRingDefinition storeOn: s.
		s contents].
	self assert: st = '(RGMethodDefinition className: ''Point'' selector: #x isMetaSide: false)'! !

!RBCollectionMessagesToExternalObjectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCollectionMessagesToExternalObjectRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 61! !

!RBDetectContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBDetectContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 65! !

!RBExcessiveVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveVariablesRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 16! !

!RBAsOrderedCollectionNotNeededRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAsOrderedCollectionNotNeededRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 55! !

!RBSendsDifferentSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsDifferentSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 37! !

!RBVariableNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableNotDefinedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 52! !

!RBSendsDeprecatedMethodToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsDeprecatedMethodToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 87! !

!RBClassVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 9! !

!RBAssignmentInIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentInIfTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 105! !

!RBLiteralArrayCharactersRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayCharactersRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 77! !

!RBMissingYourselfRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingYourselfRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 79! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/24/2012 18:42'!
filterRules
	| allRules |
	
	allRules := (self rulesFor: RBBasicLintRule) asOrderedCollection.
	allRules addAll: (self rulesFor:  RBTransformationRule).
	
	allRules := allRules reject: [:rule | rule group = 'Spelling' or: [rule group = 'Grease Formatting' ]].
		
	"allRules := allRules reject: [:rule | rule class == RBMethodHasNoCommentRule
	allRules := allRules reject: [:rule | rule class == RBReturnFormattingRule ]."
	
	^self rules: allRules  name: 'All checks'! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCompositeLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 102! !

!RBCascadedNextPutAllsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBCascadedNextPutAllsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 108! !

!RBOnlyReadOrWrittenVariableRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOnlyReadOrWrittenVariableRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 33! !

!RBSentNotImplementedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSentNotImplementedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 38! !

!RBLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:28'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:23'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	^ 0! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/29/2012 13:10'!
classesRejected
	
	| filter manifestBuilder ruleId packageName|
	
	manifestBuilder := BuilderManifest new.
	filter := OrderedCollection new.
	ruleId := self class uniqueIdentifierNumber.
	
	manifestBuilder class allManifestClasses do: [:each  | manifestBuilder manifest: each. 
 		(manifestBuilder rejectRules anySatisfy:  [:id | id = ruleId] ) 
			ifTrue: [ 
				packageName := manifestBuilder packageNameOf: each.
				(Smalltalk allClasses select: [:cl| (manifestBuilder packageNameOf: cl) = packageName]) 
					do: [:class |filter add: class theNonMetaClass.   
						filter add: class theMetaClass]].
				filter addAll: manifestBuilder rejectClasses.].

	^ filter	
	! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/1/2012 11:17'!
isTransformationRule

	^ false ! !

!RBLintRule methodsFor: '*Manifest-Core' stamp: 'SimonAllier 2/1/2012 11:28'!
result
	^ self subclassResponsibility! !

!RBJustSendsSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBJustSendsSuperRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 21! !

!RBLiteralArrayContainsCommaRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBLiteralArrayContainsCommaRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 22! !

!RBAssignmentInBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBAssignmentInBlockRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 56! !

!RBEqualNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualNilRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 110! !

!RBSuperSendsNewRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSuperSendsNewRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 40! !

!RBTemporaryVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTemporaryVariableCapitalizationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 42! !

!RBThreeElementPointRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBThreeElementPointRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 91! !

!RBUnderscoreAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnderscoreAssignmentRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 116! !

!RBUnoptimizedToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnoptimizedToDoRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 98! !

!RGMetaclassDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:17'!
storeOn: aStream
	
	aStream nextPut: $(. 
	super storeOn: aStream.
	aStream nextPutAll: ' baseClass:'.
	self theNonMetaClass storeOn: aStream.
	aStream nextPut: $).
	
! !

!RBClassInstVarNotInitializedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassInstVarNotInitializedRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 6! !

!RBOverridesSpecialMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOverridesSpecialMessageRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 34! !

!RBConsistencyCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBConsistencyCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 63! !

!RBExcessiveMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBExcessiveMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 15! !

!RBOnlyReadOrWrittenTemporaryRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBOnlyReadOrWrittenTemporaryRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 81! !

!RBClassNameInSelectorRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBClassNameInSelectorRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 7! !

!RBSendsUnknownMessageToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSendsUnknownMessageToGlobalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 88! !

!RBVariableAssignedLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBVariableAssignedLiteralRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 51! !

!RBMissingSubclassResponsibilityRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMissingSubclassResponsibilityRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 30! !

!RBMethodModifierFinalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBMethodModifierFinalRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 26! !

!RBUtilityMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUtilityMethodsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 50! !

!RBIfTrueReturnsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBIfTrueReturnsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 75! !

!RBContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBContainsRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 64! !

!RBIfTrueBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBIfTrueBlocksRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 74! !

!RBUnoptimizedAndOrRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUnoptimizedAndOrRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 97! !

!RBUsesTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBUsesTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 49! !

!RGClassDescriptionDefinition methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 16:51'!
storeOn: aStream

	aStream nextPutAll: '('; nextPutAll: self class name; 
			nextPutAll: ' named: #'; nextPutAll: name;
			nextPut: $).
			! !

!RBEqualsTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBEqualsTrueRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 69! !

!RBReturnInEnsureRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnInEnsureRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 84! !

!RBBasicLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBBasicLintRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 1! !

!RBReturnsBooleanAndOtherRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBReturnsBooleanAndOtherRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 36! !

!RBStringConcatenationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBStringConcatenationRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 90! !

!RBTempVarOverridesInstVarRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBTempVarOverridesInstVarRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 41! !

!RBSizeCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/26/2012 17:29'!
identifierMinorVersionNumber
	"This number identifies the version of the rule definition. Each time the rule is updated and its changes invalidates previous false positives identification (and as such should be reassessed by developers) the number should be increased."
	^ 1! !

!RBSizeCheckRule class methodsFor: '*Manifest-Core' stamp: 'SimonAllier 1/25/2012 16:30'!
uniqueIdentifierNumber
	"This number should be unique and should change only when the rule completely change semantics"
	
	^ 89! !

Object subclass: #BuilderManifest
	instanceVariableNames: 'manifestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!BuilderManifest commentStamp: '<historical>' prior: 0!
A ManifestBuilder is used to create, read and write a Manifest 

Instance Variables
	manifestClass:		<Object>

manifestClass
	- xxxxx
!

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/29/2012 13:09'!
allManifestClasses

	^ Smalltalk allClasses select: [:class | class name beginsWith: 'Manifest']! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/13/2012 14:09'!
falsePositiveBeginningTag
	"the string that identifies uniquely the beginning of a selector who give  the set of false positive for a rule"
	
	^ 'rule'! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/13/2012 14:09'!
falsePositiveEndTag
	"the string that identifies uniquely the end of a selector who give  the set of false positive for a rule"
	
	^ 'FalsePositive'! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/13/2012 14:09'!
falsePositiveMiddleTag
	"the string that identifies uniquely the middle of a selector who give  the set of false positive for a rule"
	
	^ 'V'! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 1/23/2012 13:33'!
manifestTag
	"the string that identifies uniquely the beginning of a Manifest class name"
	
	^ 'Manifest'! !

!BuilderManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 2/1/2012 17:07'!
on: aPackageName

	| mb |

	mb := self new. 
	(mb manifestOf: aPackageName) 
		ifNil: [ mb createManifestOf: aPackageName].
	
	^ mb	
! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/1/2012 11:04'!
rejectClassesTag
	"the string that identifies uniquely the beginning of a selector who give  the set of rejected classes"
	
	^ 'rejectClasses'! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/1/2012 11:05'!
rejectRulesTag
	"the string that identifies uniquely the beginning of a selector who give  the set of rejected rules"
	
	^ 'rejectRules'! !

!BuilderManifest class methodsFor: 'utils' stamp: 'SimonAllier 2/9/2012 10:49'!
truePositiveEndTag
	"the string that identifies uniquely the end of a selector who give  the set of false positive for a rule"
	
	^ 'TruePositive'! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 3/5/2012 16:37'!
addFalsePositive: fp of: ruleId version: versionId
	| selector falsePositives newFalsePositives arrayString |
	
	selector := self selectorFalsePositiveOf: ruleId version: versionId. 
	falsePositives := self falsePositiveOf: ruleId version: versionId.
	
	newFalsePositives := Set newFrom: falsePositives.
	newFalsePositives add: fp. .
	
	arrayString := self buildArrayString: newFalsePositives.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'
	
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/8/2012 17:40'!
addRejectClass: aClass

	|  falsePositives |
	falsePositives :=  self rejectClasses  asOrderedCollection.
	falsePositives add: aClass.
	 
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ ',  (self buildArrayString: falsePositives))
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/8/2012 17:40'!
addRejectRule: ruleId 

	|  nfp |	
	nfp := manifestClass rejectRules asOrderedCollection.
	nfp add: ruleId.
	nfp := nfp asArray.
	manifestClass class compile: 
		(self class rejectRulesTag, Character cr asString, '^ ', nfp asString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 3/5/2012 16:36'!
addTruePositive: fp of: ruleId version: versionId
	| selector falsePositives newFalsePositives arrayString |
	
	selector := self selectorTruePositiveOf: ruleId version: versionId. 
	falsePositives := self truePositiveOf: ruleId version: versionId.
	
	newFalsePositives := Set newFrom: falsePositives.
	newFalsePositives add: fp. .
	
	arrayString := self buildArrayString: newFalsePositives.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'
	
	! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 2/8/2012 14:19'!
buildArrayString: aCollection
	
	^ String streamContents: [:stream | 
		stream << '#('.
		aCollection do: [:each |  
			stream nextPut: $#.
			stream nextPutAll: each asRingDefinition storeString printString.].
		stream << ')']! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/9/2012 14:26'!
cleanUp
! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/13/2012 14:15'!
containsFalsePositive: aItem onRule: ruleId version: versionId

	^  (self hasFalsePositiveOf: ruleId version: versionId) 
		and: [(self falsePositiveOf: ruleId version: versionId) 
			anySatisfy: [:fp| fp = aItem]] ! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/13/2012 14:14'!
containsRejectedClass: aClass
	
	^ self rejectClasses anySatisfy: [:cl| cl = aClass]! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/13/2012 14:15'!
containsRejectedRule: aRuleId
	
	^ self rejectRules  anySatisfy: [:fp| fp = aRuleId]! !

!BuilderManifest methodsFor: 'creating' stamp: 'SimonAllier 2/29/2012 11:58'!
createManifestOf: elem

	 | packageName |
	
	packageName := self packageNameOf: elem.
	
	 manifestClass := Object subclass: (self class manifestTag, packageName onlyLetters) asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: packageName.
	
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ #()')
		classified: 'meta data'.
	
	manifestClass class compile: 
		(self class rejectRulesTag, Character cr asString, '^ #()')
		classified: 'meta data'.		
	
	^ manifestClass! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 3/5/2012 16:28'!
dateAsString
	| date |
	
	date := Date dateAndTimeNow.
	
	^ String streamContents: [:stream | 
		stream << '#('  
			<< (date at: 1) 
			<< ' '
			<< (date at: 2) 
			<< ')']! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/13/2012 15:52'!
dropManifestOf: ruleId version: versionId

	manifestClass class removeSelector: (self selectorFalsePositiveOf: ruleId version: versionId)! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/9/2012 10:51'!
falsePositiveOf: ruleId version: versionId 

	^ self unwrap: (
		manifestClass class 
			withArgs: #() 
			executeMethod:  (manifestClass class compiledMethodAt: (self selectorFalsePositiveOf: ruleId version: versionId)))! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/9/2012 10:51'!
hasFalsePositiveOf: ruleId version: versionId
	^ manifestClass respondsTo: (self selectorFalsePositiveOf: ruleId version: versionId)  
	! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/10/2012 10:48'!
hasTruePositiveOf: ruleId version: versionId
	^ manifestClass respondsTo: (self selectorTruePositiveOf: ruleId version: versionId)  
	! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/9/2012 10:51'!
installFalsePositiveOf: ruleId version: versionId
	"self installFalsePositiveForRule: 1 "
	
	manifestClass class 
		compile: ((self selectorFalsePositiveOf: ruleId version: versionId) asString, '^ #()')
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/9/2012 14:01'!
installTruePositiveOf: ruleId version: versionId
	"self installFalsePositiveForRule: 1 "
	
	manifestClass class 
		compile: ((self selectorTruePositiveOf: ruleId version: versionId) asString, '^ #()')
		classified: 'meta data'! !

!BuilderManifest methodsFor: 'accessing' stamp: 'SimonAllier 1/17/2012 15:20'!
manifest
	^ manifestClass! !

!BuilderManifest methodsFor: 'accessing' stamp: 'SimonAllier 2/9/2012 13:38'!
manifest: aManifest
	manifestClass := aManifest
	
! !

!BuilderManifest methodsFor: 'accessing' stamp: 'SimonAllier 2/29/2012 13:10'!
manifestOf: elem

	 | packageName |
	
	packageName := self packageNameOf: elem.
	
	manifestClass := self class allManifestClasses 
		detect: [:each | each category = packageName  ]
		ifNone: [ nil ].
		
	^ manifestClass
		
! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 2/10/2012 10:47'!
packageNameOf: elem
	| categoryName |
	elem isString
		ifTrue: [ categoryName := elem ].
	elem isBehavior
		ifTrue: [ categoryName := elem theNonMetaClass category ].
	elem isCompiledMethod
		ifTrue: [ 
			categoryName := (elem category anySatisfy: [ :ch | ch = $* ])
				ifTrue: [ (elem category subStrings: '*') first ]
				ifFalse: [ elem methodClass theNonMetaClass category ] ].
	^ (categoryName subStrings: '-') first! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 1/23/2012 11:39'!
rejectClasses
	^ self unwrap: (manifestClass rejectClasses)
! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 3/1/2012 10:31'!
rejectRules
	
	^ (manifestClass respondsTo: #rejectRules)
		ifTrue: [manifestClass rejectRules]
		ifFalse: [ #() ]
	
! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 3/5/2012 11:03'!
removeFalsePositive: fp of: ruleId version: versionId
	| selector falsePositives newFalsePositives arrayString |
	
	selector := self selectorFalsePositiveOf:ruleId version: versionId. 
	falsePositives := self falsePositiveOf: ruleId version: versionId.
	
	newFalsePositives := Set newFrom: falsePositives.
	newFalsePositives remove: fp ifAbsent: [^ self].
	
	
	arrayString := self buildArrayString: newFalsePositives.
	
	manifestClass class 
		compile: (selector asString,  Character cr asString, '^ ',arrayString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 3/7/2012 14:04'!
removeRejectClass: aClass

	|  classes |
	classes :=  self rejectClasses  asOrderedCollection.
	classes remove: aClass ifAbsent: [^ self].
	
	 
	manifestClass class 
		compile: (self class rejectClassesTag, Character cr asString, '^ ',  (self buildArrayString: classes))
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 3/7/2012 14:14'!
removeRejectRule: ruleId 

	|  nfp |	
	nfp := manifestClass rejectRules asOrderedCollection.
	nfp remove: ruleId ifAbsent: [^ self].
	
	nfp := nfp asArray.
	manifestClass class 
		compile: (self class rejectRulesTag, Character cr asString, '^ ', nfp asString)
		classified: 'meta data'
	! !

!BuilderManifest methodsFor: 'adding/removing' stamp: 'SimonAllier 2/9/2012 10:51'!
resetFalsePositiveOf: ruleId version: versionId
 	| selector |
	selector := self selectorFalsePositiveOf: ruleId version: 0.  
	self class removeSelector: selector.
	self class installFalsePositiveOf: selector version: versionId. ! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 2/13/2012 14:10'!
selectorFalsePositiveOf: ruleId version: versionId
	^ (self class falsePositiveBeginningTag, ruleId asString ,
	self class falsePositiveMiddleTag, versionId asString,
	self class falsePositiveEndTag) 
		asSymbol.! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 2/13/2012 14:10'!
selectorTruePositiveOf: ruleId version: versionId
	^ (self class falsePositiveBeginningTag, ruleId asString ,
	self class falsePositiveMiddleTag, versionId asString,
	self class truePositiveEndTag) 
		asSymbol.! !

!BuilderManifest methodsFor: 'manifest' stamp: 'SimonAllier 2/9/2012 10:52'!
truePositiveOf: ruleId version: versionId 

	^ self unwrap: (
		manifestClass class 
			withArgs: #() 
			executeMethod:  (manifestClass class compiledMethodAt: (self selectorTruePositiveOf: ruleId version: versionId)))! !

!BuilderManifest methodsFor: 'utils' stamp: 'SimonAllier 3/5/2012 16:37'!
unwrap: aCollection
	| unwrapCollection rgobject|
	unwrapCollection := OrderedCollection new.
	aCollection
		do: [ :each | 
			rgobject := Object readFrom: each.
			(rgobject isClass and: [ rgobject realClass notNil ])
				ifTrue: [ unwrapCollection add: rgobject realClass ].
			(rgobject isMethod and: [ rgobject method notNil ])
				ifTrue: [ unwrapCollection add: rgobject method ] ].
	^ unwrapCollection! !

Object subclass: #CachedManifest
	instanceVariableNames: 'falsePositives truePositives environment rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Manifest-Core'!

!CachedManifest class methodsFor: 'instance creation' stamp: 'SimonAllier 3/2/2012 12:11'!
onRules: rules environment: env
	
	^ self new
		rules: rules;
		environment: env;
		init;
		yourself! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 10:48'!
addAllFalsePositive: aCollectionOfCritic onRuleId: aRuleId
	
	falsePositives at: aRuleId 
	ifPresent: [:fp | fp addAll: aCollectionOfCritic]
	ifAbsent: [ |fp| 
		fp := Set new.
		fp addAll: aCollectionOfCritic.
		falsePositives at: aRuleId put: fp].
	! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 11:21'!
addAllTruePositive: aCollectionOfCritic onRuleId: aRuleId

	truePositives at: aRuleId 
	ifPresent: [:tp | tp addAll: aCollectionOfCritic]
	ifAbsent: [ |tp| 
		tp := Set new.
		tp addAll: aCollectionOfCritic.
		truePositives at: aRuleId put: tp]! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 10:47'!
addFalsePositive: aCritic onRuleId: aRuleId
	falsePositives at: aRuleId 
	ifPresent: [:fp | fp add: aCritic]
	ifAbsent: [ |fp| 
		fp := Set new.
		fp add: aCritic.
		falsePositives at: aRuleId put: fp]! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 11:13'!
addTruePositive: aCritic onRuleId: aRuleId

	truePositives at: aRuleId 
	ifPresent: [:tp | tp add: aCritic]
	ifAbsent: [ |tp| 
		tp := Set new.
		tp add: aCritic.
		truePositives at: aRuleId put: tp]! !

!CachedManifest methodsFor: 'accessing' stamp: 'SimonAllier 3/2/2012 11:32'!
environment: env

	environment := env! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 10:59'!
falsePositive: aCollectionOfCritic onRuleId: aRuleId

	falsePositives at: aRuleId put: aCollectionOfCritic 
	! !

!CachedManifest methodsFor: 'as yet unclassified' stamp: 'SimonAllier 3/2/2012 11:22'!
falsePositiveOf: ruleId
	^ falsePositives at: ruleId ifAbsent: [ #() ]! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 11:32'!
init
	self initializeFalsePositives.
	self initializeTruePositives  ! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 10:40'!
initialize
	super initialize.
	
	falsePositives := Dictionary new. 
	truePositives := Dictionary new. ! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 12:04'!
initializeFalsePositives
	| rV rId manifestBuilder |
	

	
	environment packageNames do: [:package |
		manifestBuilder := BuilderManifest on: package..
		rules do: [: rule |
			rId := rule class uniqueIdentifierNumber.
			rV :=  rule class identifierMinorVersionNumber.  
			(manifestBuilder hasFalsePositiveOf: rId version: rV) 
				ifTrue: [
					self addAllFalsePositive:  (manifestBuilder falsePositiveOf: rId version: rV) onRuleId: rId 
				]
		]
	]
	! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/2/2012 12:06'!
initializeTruePositives
	| rV rId manifestBuilder |
	
	environment packageNames do: [:package |
		manifestBuilder := BuilderManifest on: package.
		
		rules do: [: rule |
			rId := rule class uniqueIdentifierNumber.
			rV :=  rule class identifierMinorVersionNumber.  
			(manifestBuilder hasTruePositiveOf: rId version: rV) 
				ifTrue: [
					self addAllTruePositive:  (manifestBuilder truePositiveOf: rId version: rV) onRuleId: rId 
				]
		]
	]
	! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/6/2012 15:58'!
removeAllFalsePositive: aCollectionOfCritic onRuleId: aRuleId
	
	falsePositives at: aRuleId 
		ifPresent: [:fp | fp removeAll: aCollectionOfCritic]
		ifAbsent: []
	! !

!CachedManifest methodsFor: 'accessing' stamp: 'SimonAllier 3/2/2012 11:31'!
rules: aRules

	rules := aRules! !

!CachedManifest methodsFor: 'initialize-release' stamp: 'SimonAllier 3/5/2012 10:59'!
truePositive: aCollectionOfCritic onRuleId: aRuleId

	truePositives at: aRuleId put: aCollectionOfCritic! !

!CachedManifest methodsFor: 'as yet unclassified' stamp: 'SimonAllier 3/2/2012 11:22'!
truePositiveOf: ruleId
	^ truePositives at: ruleId ifAbsent: [ #() ]! !
